import argparse
import sys

import cv2

def main():
    argparser = argparse.ArgumentParser()
    argparser.add_argument("video", help="Video file to use")
    argparser.add_argument("out_file", help="Where to output the results", type=argparse.FileType("a"), default=sys.stdout, nargs="?")
    argparser.add_argument("-s", "--start-at", help="Frame to start at", default=0, type=int)
    args = argparser.parse_args()

    video = cv2.VideoCapture(args.video)
    i = args.start_at - 1
    video.set(cv2.CAP_PROP_POS_FRAMES, args.start_at)
    while True:
        ret, frame = video.read()
        # i += 1
        # print(i)
        if ret is False:
            break
        while True:
            cv2.imshow("Labelling", frame)
            key = chr(cv2.waitKey(0))
            if key == '\x1b':
                return
            if key in {"q", "b"}:
                args.out_file.write(key + "\n")
                break
            
        
if __name__ == "__main__":
    main()