//
// Created by jordi on 11/02/18.
//

#ifndef TFG_BALLHISTORY_H
#define TFG_BALLHISTORY_H

#include <list>
#include <vector>
#include "HistoryElem.h"

class BallHistory {
public:
    static constexpr float RESIDUAL_THRESHOLD = 0.6;

    BallHistory();

    void addTrackingElement(const HistoryElem &elem);

    void addBounceElement(const HistoryElem &elem);

    bool wasFullyDetected();

    cv::Point2f getLastPoint();

    cv::Point2f getBounce();

    int numOfLastDetections(int n);
    void printHistory();

    std::list<HistoryElem> mergedHistories();

    std::list<HistoryElem> trackingHistory = std::list<HistoryElem>();
    std::list<HistoryElem> bounceHistory = std::list<HistoryElem>();
private:
    float calculatePolynomialFittingResidual(std::vector<float> x, std::vector<float> y);

    std::list<HistoryElem> internalTrackingHistory = std::list<HistoryElem>();

    cv::Point2f calculateBouncePoint(std::vector<float> x, std::vector<float> y, float bounceX);

};


#endif //TFG_BALLHISTORY_H
