//
// Created by jordi on 11/02/18.
//

#ifndef TFG_HISTORYELEM_H
#define TFG_HISTORYELEM_H


#include <opencv2/core/core.hpp>
#include <chrono>

#define NULL_POINT cv::Point2f(-1, -1)

class HistoryElem {
public:
    HistoryElem(cv::Point2f point, float height, bool fullyDetected, bool isBounce);

    bool wasFullyDetected();

    bool hasBounced();
    cv::Point2f getPoint() const;

    long getTimestamp() const;

    bool operator<(const HistoryElem &a);
private:
    cv::Point2f point;
    float height;
    bool fullyDetected;
    bool isBounce;
    std::chrono::system_clock::time_point timestamp = std::chrono::system_clock::now();
};


#endif //TFG_HISTORYELEM_H
