//
// Created by jordi on 11/02/18.
//

#ifndef TFG_PIPELINE_H
#define TFG_PIPELINE_H

#include <tuple>

#include <opencv2/opencv.hpp>
#include "BallDetector.h"
#include "BallHistory.h"

class Pipeline {
public:
    explicit Pipeline();

    bool process(const cv::Mat &mat);

    BallHistory ballHistory = BallHistory();
private:
    Ptr<cuda::BackgroundSubtractorMOG2> backgroundSubtractor;
    BallDetector ballDetector = BallDetector();
    Ptr<cv::cuda::Filter> gaussianFilter;
    cv::cuda::Stream stream;

    std::tuple<Point2f, bool> detectBall(const cv::Mat &mat);
};


#endif //TFG_PIPELINE_H
